#!usr/bin/perl
# This script is a part of gFACs: https://gitlab.com/PlantGenomicsLab/gFACs
# Copyright (C) 2018 Madison Caballero
open (GTF, $ARGV[0])
         or die "No input gtf specified!!!";                    # This is the input file specified by gstats.pl
open (OUTPUT, $ARGV[1])
        or die "No out output destination specified!!!";        # This is the output destination specified by gstats.pl

@GTF = <GTF>;
$GTF = join "", @GTF;
@GTF = split "\n", $GTF;
$temp_loc = $ARGV[1] . "\/" . "\/" . $ARGV[2] . "temp_file.txt";

$last = 0;
foreach $line (@GTF){
  $line =~ s/\s+$//;
  @split_line = split "\t", $line;
          if($line =~ /AUGUSTUS/){
                  $split_line[8] =~ /(\d+)/;
                  $id = $1;
          }
          if($line =~ /hmm/){
                  $split_line[8] =~ /(\d+\_g)/;
                  $id = $1;
          }

  $sort{$id} = $line;
}

open (TEMPORARY_OUTFILE, ">$temp_loc");
foreach $gene (sort {$a <=> $b} keys %sort){
   foreach $line (@GTF){
	  $line =~ s/\s+$//;
	  @split_line = split "\t", $line;
	  if($line =~ /AUGUSTUS/){
		  $split_line[8] =~ /(\d+)/;
	          $id = $1;
	  
	  if ($id == $gene and $line =~ /\texon\t/){
		print TEMPORARY_OUTFILE $line, "\n"; 
	  }
	}
   }
}
close TEMPORARY_OUTFILE;
close GTF;

open (TEMPORARY_OUTFILE, ">>$temp_loc");
foreach $gene (sort {$a <=> $b} keys %sort){
   foreach $line (@GTF){
          $line =~ s/\s+$//;
          @split_line = split "\t", $line;
          if($line =~ /hmm/){
                  $split_line[8] =~ /(\d+\_g)/;
                  $id = $1;
          
          if ($id == $gene and $line =~ /\texon\t/){
                print TEMPORARY_OUTFILE $line, "\n";
          }
	}
   }
}
close TEMPORARY_OUTFILE;
close GTF;


open (TEMPORARY_INFILE, "$temp_loc");
$temp_loc = $ARGV[1] . "\/" . "\/" . $ARGV[2] . "temp_2_file.txt";
open (TEMPORARY_OUTFILE, ">$temp_loc");

$last_id = 1;
while ($line = <TEMPORARY_INFILE>){
	$line =~ s/\s+$//;
        @split_line = split "\t", $line;
#	2R      AUGUSTUS        exon    404059  404511  .       +       .       transcript_id "g1.t1"; gene_id "g1";

          if($line =~ /AUGUSTUS/){
                  $split_line[8] =~ /(\d+)/;
                  $id = $1;
          }
          if($line =~ /hmm/){
                  $split_line[8] =~ /(\d+\_g)/;
                  $id = $1;
          }

	if($id == $last_id){
		push @loc, $split_line[3];
	        push @loc, $split_line[4];
		push @lines, $line;
	}
	if($id !~ $last_id){
		@last_split = split "\t", $line_line;
		@sort = sort {$a <=> $b} @loc;
		print TEMPORARY_OUTFILE "###", "\n",
		$last_split[0], "\t",
                $last_split[1], "\t",
                "gene", "\t",
		$sort[0], "\t", $sort[scalar @loc -1], "\t",
		$last_split[5], "\t",
                $last_split[6], "\t",
                $last_split[7], "\t",
		"g", $last_id, "\n";

		foreach $line (@lines){
			print TEMPORARY_OUTFILE $line, "\n";
		}
		undef(@lines);
		undef(@loc);

                 push @loc, $split_line[3];
                push @loc, $split_line[4];
                push @lines, $line;

	}
	$last_id = $id;
	$line_line = $line;
}

close TEMPORARY_INFILE;
close TEMPORARY_OUTFILE;


open (GTF, "$temp_loc") or die "Cannot find temp_file.txt at $ARGV[1]!!!";
@GTF = <GTF>;
$GTF = join "", @GTF;
@GTF = split "###", $GTF;


$gene_table = $ARGV[1] . "\/" . "\/" . $ARGV[2] . "gene_table.txt";
open (GENE_TABLE, ">$gene_table") or die "Cannot find gene_table.txt at $ARGV[1]!!!";
print GENE_TABLE "###", "\n";

foreach $gene (@GTF){
	$gene =~ s/\s+$//g;
	@lines = split "\n", $gene;

	foreach $line (@lines){
		@split_line = split "\t", $line;
		
		if ($split_line[2] =~ /gene/){
			$gene_length = $split_line[4] - $split_line[3] + 1;

			          if($line =~ /AUGUSTUS/){
                                          $split_line[8] =~ /(g\d+)/;
                                          $id = $1;
			          }
			          if($line =~ /hmm/){
			                  $split_line[8] =~ /(\d+\_g)/;
			                  $id = $1;
			          }


			print GENE_TABLE $split_line[2],			# gene
				"\t", $gene_length,				# length 
				"\t", $split_line[3], 				# start
				"\t", $split_line[4], 				# stop
				"\t", $split_line[6], 				# strand
				"\t", "ID=", $id, 				# ID
				"\t", $split_line[0],
				"\n";
		}
		if ($split_line[2] =~ /exon/){
			$exon_length = $split_line[4] - $split_line[3] + 1;


                                  if($line =~ /AUGUSTUS/){
                                          $split_line[8] =~ /(g\d+.t\d+)/;
                                          $trans = $1;
                                  }
                                  if($line =~ /hmm/){
                                          $split_line[8] =~ /(\d+\_t)/;
                                          $trans = $1;

                                  }

			 print GENE_TABLE $split_line[2],                       # exon
				"\t", $exon_length,				# length
                                "\t", $split_line[3],                           # start
                                "\t", $split_line[4],                           # stop
                                "\t", $split_line[6],                           # strand
                                "\t", "Parent=", $trans,                           # ID
				 "\t", $split_line[0],
                                "\n";

			push @exons, $split_line[3];
			push @exons, $split_line[4];
		}
		

	}
	if (scalar @exons >= 4){
                @exons_sorted = sort {$a <=> $b} @exons;
                # 10    20      30      40      50      60
                #[0]    [1]-----[2]     [3]-----[4]     [5]
                # Intron = [2] - [1] and [4] - [3]

                for ($a = 2; $a < scalar @exons_sorted; $a = $a +2){
			$end = $exons_sorted[$a] - 1;
                        $start = $exons_sorted[$a-1] + 1;
                        $intron_length = $end - $start + 1;
						
	                        print GENE_TABLE "intron",
	                                "\t", $intron_length,
	                                "\t", $start,
	                                "\t", $end,
	                                "\t", $split_line[6],
					"\t", ".",
					 "\t", $split_line[0],
	                                "\n";
			
                        }
                }

	
print GENE_TABLE "###", "\n";
undef (@exons);
undef (@introns);
}		
close GENE_TABLE;
close GTF;
